program CurvaCZoom;

{Occorre l'unit Crt per avere le instruzioni di lettura
e scrittura. Occorre l'unit Graph per avere le instruzioni di grafica}
uses Crt, Graph;

{Dichiariamo due variabili di tipo intero piccolo
contenenti informazioni sulla scheda usata dal vostro computer e sul modo
con cui viene utilizzata.}
var Scheda, Modo: smallint;


const MaxDepth=50;
Xmin=-0.5; Xmax=+0.5; Ymin=-0.25; Ymax=+1.25;
 {CURVA C: -1,0.5,-0.5,1.5 per la curva a C}
 {ELOISA: Xmin=-0.5; Xmax=+0.5; Ymin=-0.25; Ymax=+1.25; }
A1=1; A2=1; A3=0; A4=1; A5=-1; A6=1;
B1=-1; B2=1; B3=0; B4=1; B5=1; B6=0;

var Max:Integer;

function K(xx:Double; yy:Double) :Integer;
var
X: array [0..MaxDepth] of Double;
Y: array [0..MaxDepth] of Double;
D: array [0..MaxDepth] of Integer;
i, Depth:Integer;

begin
i:=0; Depth:=0;
X[i]:=xx;Y[i]:=yy;D[i]:=0;

 while (i>=0) and (Depth<(Max-1))
 do
  if ((Xmin<=X[i]) and (X[i]<=Xmax) and
      (Ymin<=Y[i]) and (Y[i]<=Ymax))
   then
    begin
      if (D[i]>=Depth)
       then Depth := D[i]+1;
      xx     := X[i];
      yy     := Y[i];
      X[i]   := A1*xx+A2*yy+A3;
      Y[i]   := B1*xx+B2*yy+B3;
      D[i]   := D[i]+1;
      X[i+1] := A4*xx+A5*yy+A6;
      Y[i+1] := B4*xx+B5*yy+B6;
      D[i+1] := D[i];
      i:=i+1;
    end
      else i:=i-1;

K:=Depth;
end;


var AA, BB, CC, DD, EE, FF:array [1..7] of Real;
var dp:Integer;

function K2(xx:Double; yy:Double) :Integer;
var
X: array [0..7*MaxDepth] of Double;
Y: array [0..7*MaxDepth] of Double;
D: array [0..7*MaxDepth] of Integer;
i, j, Depth:Integer;

begin
AA[1] := 2.59808;
AA[2] := 3.;
AA[3] := 2.59808;
AA[4] := 1.5;
AA[5] := 0;
AA[6] := 1.5;
AA[7] := 0;

BB[1] := 1.5;
BB[2] :=0;
BB[3] :=-1.5;
BB[4] :=2.59808;
BB[5] :=-3.;
BB[6] :=-2.59808;
BB[7] :=3.;

CC[1] := -0.5;
CC[2] :=0;
CC[3] :=1.;
CC[4] :=-0.366025;
CC[5] :=1.5;
CC[6] :=2.23205;
CC[7] :=-1.5;

DD[1] := -1.5;
DD[2] := 0;
DD[3] := 1.5;
DD[4] := -2.59808;
DD[5] := 3.;
DD[6] := 2.59808;
DD[7] := -3.;

EE[1] := 2.59808;
EE[2] := 3.;
EE[3] := 2.59808;
EE[4] := 1.5;
EE[5] :=0;
EE[6] :=1.5;
EE[7] :=0;

FF[1] :=0.133975;
FF[2] :=-1.;
FF[3] :=-1.73205;
FF[4] :=1.36603;
FF[5] :=0;
FF[6] :=-1.86603;
FF[7] :=1.;


i:=0; Depth:=0;
X[i]:=xx;Y[i]:=yy;D[i]:=0;

 while (i>=0) and (Depth<(Max-1))
 do
  if ((Xmin<=X[i]) and (X[i]<=Xmax) and
      (Ymin<=Y[i]) and (Y[i]<=Ymax))
   then
    begin
      if (D[i]>=Depth)
       then Depth := D[i]+1;
      xx     := X[i];
      yy     := Y[i];
      dp     := D[i]+1;
      for j:=1 to 7 do
      begin
       X[i+j-1]   := AA[j]*xx+BB[j]*yy+CC[j];
       Y[i+j-1]   := DD[j]*xx+EE[j]*yy+FF[j];
       D[i+j-1]   := dp;
      end;
      i:=i+7-1;
    end
      else i:=i-1;

K2:=Depth;
end;



var i,j:Integer;
var continua1, continua2 : Char;
const M = 256*3;
const N = M;  {oppure round(3*M/4);  per includere l'intera curva in un rettangolo}
var cx, cy, vx, vy:Double;
var d:Double;
var s:Double;

begin

{Inseriamo in Scheda il numero di Scheda del vostro computer}
 Scheda:=Detect;

 {Comunichiamo al Pascal il numero della vostra scheda, e la posizione del
 vostri file di grafica. ***ATTENZIONE*** se il vostro Pascal non si trova in
 'C:\Dev-Pas' dovete rimpiazzare 'C:\Dev-Pas' con la posizione della vostra
 cartella contenente il compilatore Pascal, lasciando sempre '\bgi' (il nome
 della cartella grafica) alla fine.}
 InitGraph(Scheda,Modo,'C:\Dev-Pas\bgi');

 Max:=8; {Max = 8 per Eloisa, Max=30 per la curva a C}
{
Curva a C con un metodo di ingrandimento
e inversione di operazione di punto fisso
}

{ELOISA.}
{il punto centrale: cx:=0.16666; cy:=0.5;}
{un punto in una "chela": cx:=0.08333; cy:=0.66666; }
{un punto che, apparentemente, non produce forme periodiche:
cx:=0.08333; cy:=0.64; }
     continua1 := 'y';
cx:=0.08333; cy:=0.64;
{CURVA C. }
{un punto in una delle zone piu' scure:
     cx := -0.84375;
     cy := +0.375;                  }
{Invece, un angolo al bordo del blocco centrale:
     cx := -0.875; cy := +0.375;  ovvero (-7/8,+3/8)
 Oppure un angolo di una forma esagonale dentro il blocco centrale:
     cx:=-0.8125; cy := +0.4375;  (-13/16,+7/16)          }
{L'estremo della spirale:
     cx:=0; cy:=0;}
{Punto medio del dorso:
     cx:=-1; cy:=0.5;}
{Baricentro del blocco centrale:
     cx:=-0.875; cy:=0.5;}
     d  := 1;

     while (continua1 = 'y') do
      begin
       writeln('MENU');
       writeln(' X=',cx:5:5,' Y=',cy:5:5,' ingrandimento d=', d:3:3);
       writeln('  Premere y per disegnare, n per smettere, X,Y,d per modificare X,Y,d');
       continua1:=ReadKey;

       while (continua1 <>'y') and (continua1 <> 'n') do
        begin
        if (continua1='X') then begin write(' X=');readln(cx);end;
        if (continua1='Y') then begin write(' Y=');readln(cy);end;
        if (continua1='d') then begin write(' d=');readln(d); end;
        writeln(' X=',cx:5:5,' Y=',cy:5:5,' ingrandimento d=', d:3:3);
        writeln('  Premere y per disegnare, n per smettere, X,Y,d per modificare X,Y,d');
        continua1:=ReadKey;
        end;

       continua2:= 'y';

       while (continua1 = 'y') and (continua2 = 'y') do
       begin
       s := 2/(d*M);
       vx:=cx-(N div 2)*s;
       vy:=cy-(M div 2)*s;
       for i:=0 to M-1 do
        for j:=0 to N-1 do
         if (K2(j*s+vx,i*s+vy)=Max-1)   {K oppure K2}
          then
           PutPixel(j,i,red)       {CURVA C: black ELOISA: red}
          else
           PutPixel(j,i,white);      {CURVA C: blue. ELOISA: white}
       {rettangolo che evidenzia il prossimo ingrandimento}
       SetColor(lightred);           {CURVA C: lightred ELOISA: lighred}
       {CURVA C: ..div 4, 3*..div 4.  ELOISA: ..div 3, 2*..div 3}
       Rectangle(N div 3, M div 3, 2*N div 3, 2*M div 3);

       {croce nel centro del rettangolo}
       Line(N div 2-1, M div 2,   N div 2+1, M div 2);
       Line(N div 2,   M div 2-1, N div 2,   M div 2+1);
       s:=s/2;
       writeln(' ingradimento = ', d:3:3,
        ' Premere y per ingrandire, n per tornare al menu.');
       continua2:=ReadKey;
       if (continua2 = 'y') then
        begin
         d:=d*3; {CURVA C: Ingrandimento 2. ELOISA: 3}
         Max:=Max+1; {CURVA C: +2. ELOISA: +1}
        end;
       end;
     end;

 CloseGraph;
end.

